/*
 * CCVisu is a tool for visual graph clustering
 * and general force-directed graph layout.
 * This file is part of CCVisu.
 *
 * Copyright (C) 2005-2012  Dirk Beyer
 *
 * CCVisu is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * CCVisu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with CCVisu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Please find the GNU Lesser General Public License in file
 * license_lgpl.txt or http://www.gnu.org/licenses/lgpl.txt
 *
 * Dirk Beyer    (firstname.lastname@uni-passau.de)
 * University of Passau, Bavaria, Germany
 */
package org.sosy_lab.ccvisu.writers;

import java.io.PrintWriter;

import org.sosy_lab.ccvisu.Options;
import org.sosy_lab.ccvisu.graph.GraphData;
import org.sosy_lab.ccvisu.graph.GraphVertex;
import org.sosy_lab.ccvisu.graph.Group;
import org.sosy_lab.ccvisu.measuring.FeatureDependency;

/**
 * Writer for statistics in text format.
 */
public class WriterDataSTATS extends WriterData {

  public WriterDataSTATS(PrintWriter out, GraphData graph) {
    super(out, graph);
  }

  /**
   * Writes statistics.
   */
  @Override
  public void write() {
    out.println("# Generated by " + Options.toolDescription());
    out.println("# " + Options.currentDateTime());
    out.println("# Statistics computed by CCVisu.");

    out.println("iec\tiec(w)\tifc\tifc(w)\tpd\tar\tmr");

    // calculuate proximity degree for a feature-extended layout
    if(graph.getGroup("FEATURE") != null
        && graph.getGroup("ELEMENT") != null
        && graph.getGroups().size() == 3) {

      Group features = graph.getGroup("FEATURE");
      for (GraphVertex feature : features.getNodes()) {
        int iecExtended         = FeatureDependency.iecExtended(feature, graph);
        int iecExtendedWeighted = FeatureDependency.iecExtendedWeighted(feature, graph);
        int ifcExtended         = FeatureDependency.ifcExtended(feature, graph);
        int ifcExtendedWeighted = FeatureDependency.ifcExtendedWeighted(feature, graph);
        int pdExtendedWeighted  = FeatureDependency.pdExtendedWeighted(feature, graph);
        int arExtended          = FeatureDependency.arExtended(feature, graph);
        int mrExtended          = FeatureDependency.mrExtended(feature, graph);

        out.println(iecExtended + "\t" + iecExtendedWeighted + "\t"
            + ifcExtended + "\t" + ifcExtendedWeighted + "\t"
            + pdExtendedWeighted + "\t" + arExtended + "\t" + mrExtended + "\t"
            + feature.getName());
      }

    } else { // calculuate proximity degree for a plain layout

      for(Group feature : graph.getGroups()) {

        int iecPlain          = FeatureDependency.calculateIFD(feature, graph);
        int iecPlainWeighted  = FeatureDependency.calculateIFD_W(feature, graph);
        int ifcPlain          = FeatureDependency.calculateEFD(feature, graph);
        int ifcPlainWeighted  = FeatureDependency.calculateEFD_W(feature, graph);
        int pdPlainWeighted   = FeatureDependency.pdPlainWeighted(feature, graph);
        int arPlain           = FeatureDependency.calculateAR(feature, graph);
        int mrPlain           = FeatureDependency.calculateMR(feature, graph);

        out.println(iecPlain + "\t" + iecPlainWeighted + "\t" + ifcPlain + "\t"
            + ifcPlainWeighted + "\t" + pdPlainWeighted + "\t"+ arPlain + "\t"
            + mrPlain + "\t" + feature.getName());
      }
    }
    out.flush();
  }
}
